class Zelle
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  boolean fertig;
  int AnzahlBeruehrungen = 0;                          // effektive Anzahl Berhrungen
  int Beruehrungszaehler = 0;                          // wird bei jedem Durchgang auf null gesetzt und von Neuem hochgezhlt        
  float [] Beruehrungspunkt = new float [4];           // von den max. 2 Berhrungspunkten werden die Koordinaten gespeichert
  color col;
  float xZelle;
  float yZelle;
  float rZelle;

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Zelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  void entwickeln ()
  {
    if (fertig == false)                                                 // falls die Zelle noch nicht fertig ist
    {
      int Beruehrungen = BeruehrungenZaehlen ();                         // Zelle testen
      if (Beruehrungen == 0)                                             // keine Berhrung -> wachsen
      {
        wachsen();
      }
      else if (Beruehrungen == 1)                                         // 1 Berhrung -> bewegen
      {
        loeschen();
        bewegen_Ber_1();
        zeichnen();
      }
      else if (Beruehrungen == 2)                                         // 2 Berhrung -> bewegen
      {
        loeschen();
        bewegen_Ber_2();
        zeichnen();
      }
      else if (Beruehrungen == 3)
      {
         if (rZelle < minR)                                               // wird neu gestartet, falls sie fertig, aber zu klein ist
        {
          reset ();          
        }
        else                                                              // Zelle wird als "fertig" deklariert
        {
          fertig = true;
        }
      }
    }
  }

  //--------------------------------------------------------------------------------------------------

  
  
  
  
  
  
  void zeichnen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
    fill (Hintergrund);
    ellipse (xZelle, yZelle, rZelle-2, rZelle-2);
  }

  //--------------------------------------------------------------------------------------------------

  void loeschen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (Hintergrund);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }

  //--------------------------------------------------------------------------------------------------

  void wachsen ()
  {
    rZelle += f;
    zeichnen ();
  }

  //--------------------------------------------------------------------------------------------------

  int BeruehrungenZaehlen ()
  {
    Beruehrungszaehler = 0;

// Zellen

    for (int i=0; i<=n; i++)
    {
      float xNachbar = meineZelle [i].getGeometrie () [0];
      float yNachbar = meineZelle [i].getGeometrie () [1];
      float rNachbar = meineZelle [i].getGeometrie () [2];
      float Abstand = sqrt(sq(xNachbar - xZelle) + sq(yNachbar -yZelle));

      if (Abstand <= rZelle + minA + rNachbar && Abstand != 0)                                                          // Berhrung
      {
        setBerKoor (xZelle + (rZelle/Abstand)*(xNachbar - xZelle), yZelle + (rZelle/Abstand)*(yNachbar - yZelle));      // Koordinaten Berhrungspunkt setzen
      }
    }

// ffnungen

    for (int i=0; i < AnzahlOeffnungen; i++)
    {
      float xL = meineOeffnung [i].getGeometrie () [0];
      float xR = meineOeffnung [i].getGeometrie () [1];
      float yO = meineOeffnung [i].getGeometrie () [2];
      float yU = meineOeffnung [i].getGeometrie () [3];

      if (yZelle <= yU + rZelle + minA && yZelle >= yO - rZelle -minA && xZelle <= xR + rZelle + minA && xZelle >= xL - rZelle -minA)    // nur schlaufen, falls Berhrung mglich
      {
        if (yZelle <= yU && yZelle >= yO) {             // Berhrung links oder rechts
          if (xZelle < xL) {                            // Berhrung links
            setBerKoor (xZelle + rZelle, yZelle);
          } 
          else if (xZelle > xR) {                       // Berhrung rechts
            setBerKoor (xZelle - rZelle, yZelle);
          }
        } 
        else if (xZelle <= xR && xZelle >= xL) {        // Berhrung oben oder unten
          if (yZelle < yO) {                            // Berhrung oben
            setBerKoor (xZelle, yZelle + rZelle);
          } 
          else if (yZelle > yU) {                       // Berhrung rechts
            setBerKoor (xZelle, yZelle - rZelle);
          }
        } 
        else {                                                                     // Berhrung an einer Ecke
          if (sqrt(sq(xL - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {           // Berhrung unten links
            setBerKoor (xZelle + rZelle, yZelle - rZelle);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {      // Berhrung unten rechts
            setBerKoor (xZelle - rZelle, yZelle - rZelle);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Berhrung oben rechts
            setBerKoor (xZelle - rZelle, yZelle + rZelle);
          } 
          else if (sqrt(sq(xL - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Berhrung oben links
            setBerKoor (xZelle + rZelle, yZelle + rZelle);
          }
        }
      }

    }

// Rnder

    if (xZelle <= rZelle + minA) {                          // Berhrung links
      setBerKoor (xZelle - rZelle, yZelle);
    } else if (xZelle >= width - rZelle - minA) {           // Berhrung rechts
      setBerKoor (xZelle + rZelle, yZelle);
    } else if (yZelle <= rZelle + minA) {                   // Berhrung oben
      setBerKoor (xZelle, yZelle - rZelle);
    } else if (yZelle >= height - rZelle - minA) {           // Berhrung rechts
      setBerKoor (xZelle, yZelle + rZelle);
    }
    
    if (Beruehrungszaehler > AnzahlBeruehrungen)
    {
      AnzahlBeruehrungen = Beruehrungszaehler;
      setBeruehrungspunkt ();
    }
    return (Beruehrungszaehler);
  }

  //--------------------------------------------------------------------------------------------------

  void bewegen_Ber_1 ()
  {
    xZelle += g*(xZelle - Beruehrungspunkt [0])/rZelle;              // Mittelpunkt verschieben
    yZelle += g*(yZelle - Beruehrungspunkt [1])/rZelle;
  }

  //--------------------------------------------------------------------------------------------------

  void bewegen_Ber_2 ()
  {
    float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
    float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
    float AbstandMitte = sqrt(sq(xMitte -xZelle) + sq(yMitte -yZelle));
    xZelle += g*((xZelle - xMitte)/AbstandMitte);              // Mittelpunkt verschieben
    yZelle += g*((yZelle - yMitte)/AbstandMitte);
  }


  //--------------------------------------------------------------------------------------------------

  void setBerKoor (float x, float y)
  {
    Beruehrungszaehler++;
    if (Beruehrungszaehler<=2)
    {
      Beruehrungspunkt [Beruehrungszaehler*2-2] = x;    // x-Wert Berhrunspunkt
      Beruehrungspunkt [Beruehrungszaehler*2-1] = y;    // y-Wert Berhrunspunkt
    }
  }

  //--------------------------------------------------------------------------------------------------

  void reset ()
  {
    col = Hintergrund;                                           // Zelle lschen
    zeichnen ();

    fertig = false;                                              // Variabeln zurcksetzen
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }

  //--------------------------------------------------------------------------------------------------

  boolean getFertig ()                                // Variable "fertig" auslesen     
  {
    return fertig;
  }  

  //--------------------------------------------------------------------------------------------------  

  float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {
      xZelle, yZelle, rZelle    };
    return Geometrie;
  }  

  //--------------------------------------------------------------------------------------------------

  void setFertig (boolean f)                           // Variable "fertig" setzen
  {
    fertig = f;
    col = ZelleFertigColor;
    zeichnen ();
  }    

  // --------------------------------------------------------------------------------------------------

  void setFarbe (color c)                              // Methode: Farbe setzen
  {
    col = c;
  }    

  //--------------------------------------------------------------------------------------------------

  void setBeruehrungspunkt ()                          // wird in Unterklasse berdeckt
  {
    
  }    

  //--------------------------------------------------------------------------------------------------

}
